

; * * * * * * * * * * * * * * *
; * A rajouter                *
; * * * * * * * * * * * * * * *
; * - Vector_Different()      *
; *                           *
; * * * * * * * * * * * * * * *



; Rajout :
    ; * Vector_CreateSafeDirectory()
    ; * Vector_ImplodePtr()

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; - - - - - - - - - - - - - - OTHER FCT - - - - - - - - - - - - -
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

Procedure SwapLong(*p1.long, *p2.long)
  Protected temp.l
  If *p1 And *p2
    temp = *p1\l
    *p1\l = *p2\l
    *p2\l = temp
    ProcedureReturn #True
  Else
    ProcedureReturn #True
  EndIf
EndProcedure


ProcedureDLL.l MkStr(s.s)
  Shared VectorMkStr.s
  VectorMkStr = s
  ProcedureReturn @VectorMkStr
EndProcedure


ProcedureDLL Vector_IsIni(*list.Vector)
  If *list And *list\ini
    ProcedureReturn #True
  EndIf
EndProcedure





; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; - - - - - - - - - - - - OffSet Part - - - - - - - - - - - - - -
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
;- 01 OffSets


ProcedureDLL SVector_IsIni(*list.Vector)
  If *list And *list\ini And *list\complex & #LC_Offsets_Enabled
    ProcedureReturn #True
  EndIf
EndProcedure






ProcedureDLL SVector_RegisterType(*list.Vector, offset.b, type.b)
  Protected i.b, size.b
  
  If SVector_IsIni(*list) And *list\nb = #Null And type >= #LC_TYPE_STR
    If type = #LC_TYPE_STR
      size = 4
    Else
      size = *list\type
    EndIf
    If offset >= 0 And offset < *list\type-size
      If *list\complex = #LC_Offsets_Used
        i = offset
        While i >= 0 And *list\offset[i] <= #LC_TYPE_LG
          i - 1
        Wend
        If i >= 0
          If *list\offset[i] = #LC_TYPE_STR
            If offset-i < 4
              ProcedureReturn #False
            EndIf
          Else
            If offset-i < *list\offset[i]
              ProcedureReturn #False
            EndIf
          EndIf
        EndIf
      Else
        *list\complex = #LC_Offsets_Used
      EndIf
      *list\offset[offset] = type
      ProcedureReturn #True
    EndIf
  EndIf
EndProcedure





; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; - - - - - - - - - - - - VCell PART - - - - - - - - - - - - - -
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
;- 03 Cellules



; -------------- Creation des cellules --------------  


; Ne pas appeler cette fct
Procedure.l VCell_CreateCell(*list.Vector, val.l)
  Protected *mem.l, *cell.VCell, lenMem.l
  Protected i.b, *complex.l, *m.Long, *f.float

  *cell = AllocateMemory(SizeOf(VCell))
  If *cell
    Select *list\type
      
      Case #LC_TYPE_FLT
        *f = val
        *cell\info = *f\f
      
      Case #LC_TYPE_LG
        *cell\info = val  ; Le paramtre pr la copie est ignore ds le cas d'un Long
      
      Case #LC_TYPE_STR
        lenMem = Len(PeekS(val))
        *mem = AllocateMemory(lenMem+1)
        If *mem
          ;Debug Str(val) + " -> " + Str(*mem)
          CopyMemory(val, *mem, lenMem)
          *cell\info = *mem
        Else
          FreeMemory(*cell)
          ProcedureReturn #Null
        EndIf
      
      Default
        If *list\type < 0 ; On controle que la taille du block est positif
          FreeMemory(*cell)
          ProcedureReturn #Null
        EndIf
        *mem = AllocateMemory(*list\type)
        If *mem
          CopyMemory(val, *mem, *list\type)
          *cell\info = *mem
          
        ;{ GESTION DES STRUCTs COMPLEXES
          If *list\complex = #LC_Offsets_Used
            For i = 0 To *list\type-1
              If *list\offset[i] = #LC_TYPE_STR
                *m = *mem+i
                If *m\l
                  lenMem = Len(PeekS(*m\l))
                  *complex = AllocateMemory(lenMem+1)
                  If *complex
                    CopyMemory(*m\l, *complex, lenMem)
                    *m\l = *complex
                  EndIf
                EndIf
              ElseIf *list\offset[i] > #LC_TYPE_STR
                *m = *mem+i
                If *m\l
                  lenMem = *list\offset[i]
                  *complex = AllocateMemory(lenMem)
                  If *complex
                    CopyMemory(*m\l, *complex, lenMem)
                    *m\l = *complex
                  EndIf
                EndIf
              EndIf
            Next i
          EndIf
        ;}\ Fin de gestion des Structs Complexes
        Else
          FreeMemory(*cell)
          ProcedureReturn #Null
        EndIf
      
    EndSelect
  EndIf
  ProcedureReturn *cell
EndProcedure




; ------------ Comparaison entre deux cellules ----------------


; Ne pas appeler cette fct
Procedure VCell_Compare(val1.l, val2.l, type.b, opt.l)
  Protected *f1.float, *f2.float
  ; type :  long, str, struct
  ; opt  :  Str : case_sensitive
  ;         Str : adr de la Fct de comparaison
  ; Return : -1 si cell1 < cell2
  ;           1 si cell1 > cell2, 0 sinon
  If val1 And val2
    Select type
    
      Case #LC_TYPE_STR
        If opt & #LC_SORT_CASE
          ProcedureReturn CompareMemoryString(val1, val2, 0)
        Else
          ProcedureReturn CompareMemoryString(val1, val2, 1)
        EndIf
      
      Case #LC_TYPE_LG
        If val1 > val2
          ProcedureReturn 1
        ElseIf val1 < val2
          ProcedureReturn -1
        Else
          ProcedureReturn 0
        EndIf
      
      Case #LC_TYPE_FLT
        *f1 = val1 : *f2 = val2
        If *f1\f > *f2\f
          ProcedureReturn 1
        ElseIf *f1\f < *f2\f
          ProcedureReturn -1
        Else
          ProcedureReturn 0
        EndIf
      
      Default
        ProcedureReturn CallFunctionFast(opt, val1, val2)
    
    EndSelect
  EndIf

EndProcedure




; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
; - - - - - - - - - - - - Vector FCTs - - - - - - - - - - - - - 
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
;- 04 Liste
;- 05 ----------------------------------

; -------------- GetValue --------------
;- 10 GetValue


ProcedureDLL Vector_Count(*list.Vector)
  If Vector_IsIni(*list)
    ProcedureReturn *list\nb
  EndIf
EndProcedure


ProcedureDLL Vector_Index(*list.Vector)
  If Vector_IsIni(*list)
    ProcedureReturn *list\pos
  EndIf
  ProcedureReturn -1
EndProcedure


ProcedureDLL Vector_GetValue(*list.Vector)
  If Vector_IsIni(*list)
    If *list\current
      ProcedureReturn *list\current\info
    EndIf
  EndIf
EndProcedure


ProcedureDLL.s Vector_GetStrValue(*list.Vector)
  If Vector_IsIni(*list)
    If *list\type = #LC_TYPE_STR
      If *list\current\info
        ProcedureReturn PeekS(*list\current\info)
      EndIf
    EndIf
  EndIf
EndProcedure


ProcedureDLL.f Vector_GetFloatValue(*list.Vector)
  Protected *f.float
  If Vector_IsIni(*list)
    If *list\type = #LC_TYPE_FLT
      If *list\current\info
        *f = *list\current\info
        ProcedureReturn *f\f
      EndIf
    EndIf
  EndIf
EndProcedure


ProcedureDLL Vector_SetValue(*list.Vector, value.l)
  Protected *mem.l, lg.l, *f.float

  If Vector_IsIni(*list)
    If *list\current
      If *list\current\info >= #LC_TYPE_STR
        FreeMemory(*list\current\info)
      EndIf
      
      Select *list\type
        Case #LC_TYPE_STR
          lg = Len(PeekS(value))
          *mem = AllocateMemory(lg+1)
          If *mem = #Null
            ProcedureReturn #False
          EndIf
          CopyMemory(value, *mem, lg)
          *list\current\info = *mem
          
        Case #LC_TYPE_LG
          *list\current\info = value
        
        Case #LC_TYPE_FLT
          *f = value
          *list\current\info = *f\f
        
        Default ; Struct
          *mem = AllocateMemory(*list\type)
          If *mem = #Null
            ProcedureReturn #False
          EndIf
          CopyMemory(value, *mem, *list\type)
          *list\current\info = *mem
      EndSelect
      *list\sorted    = #False
      ProcedureReturn #True
    EndIf
  EndIf
EndProcedure


ProcedureDLL Vector_Cur(*list.Vector)
  If Vector_IsIni(*list)
    ProcedureReturn *list\current
  EndIf
EndProcedure


; -------------- Dplacement dans la liste -------------- 
;- 11 Move

ProcedureDLL Vector_Last(*list.Vector)
  If Vector_IsIni(*list)
    *list\current = *list\last
    If *list\last
      *list\pos = *list\nb-1
    Else
      *list\pos = -1
    EndIf
    ProcedureReturn *list\current
  EndIf
EndProcedure



ProcedureDLL Vector_First(*list.Vector)
  If Vector_IsIni(*list)
    *list\current = *list\first
    If *list\first
      *list\pos = 0
    Else
      *list\pos = -1
    EndIf
    ProcedureReturn *list\current
  EndIf
EndProcedure


ProcedureDLL Vector_Reset(*list.Vector)
  If Vector_IsIni(*list)
    *list\current = #Null
    *list\pos = -1
  EndIf
EndProcedure


ProcedureDLL Vector_Next(*list.Vector)
  If Vector_IsIni(*list)
    If *list\current
      *list\current = *list\current\Next
      *list\pos + 1
      ProcedureReturn *list\current
    ElseIf *list\pos = -1
      ProcedureReturn Vector_First(*list)
    EndIf
  EndIf
EndProcedure


ProcedureDLL Vector_Prev(*list.Vector)
  If Vector_IsIni(*list)
    If *list\current
      *list\current = *list\current\Prev
      *list\pos - 1
      ProcedureReturn *list\current
    ElseIf *list\pos = *list\nb
      ProcedureReturn Vector_Last(*list)
    EndIf
  EndIf
EndProcedure


ProcedureDLL Vector_Select(*list.Vector, index.l)
  If Vector_IsIni(*list)
    If index < -1 Or index > *list\nb
      ProcedureReturn  #Null
    ElseIf *list\nb
      If index = -1 Or index = *list\nb
        *list\current = #Null
        *list\pos = index
      ElseIf index = 0
        *list\current = *list\first
        *list\pos = index
      ElseIf index = *list\nb-1
        *list\current = *list\last
        *list\pos = index
      Else
        If index < *list\pos And index < *list\pos-index
          *list\current = *list\first
          *list\pos = 0
        EndIf
        If index > *list\pos And *list\nb-(index+1) < index-*list\pos
          *list\current = *list\last
          *list\pos = *list\nb - 1
        EndIf
        While (*list\pos <> index)
          If index > *list\pos
            Vector_Next(*list)
          Else
            Vector_Prev(*list)
          EndIf
        Wend
      EndIf
      ProcedureReturn *list\current
    EndIf
  EndIf
  ProcedureReturn #Null
EndProcedure


ProcedureDLL Vector_GetValue2(*list.Vector, index.l)
  If Vector_IsIni(*list)
    If Vector_Select(*list, index)
      ProcedureReturn *list\current\info
    EndIf
  EndIf
  ProcedureReturn #Null
EndProcedure


; ---------------- Swap de cellules ---------------
;- 12 Swap


ProcedureDLL Vector_Swap(*list.Vector, index1.l, index2.l)
  Protected *cell1.VCell, *cell2.VCell, *cur.VCell, pos.l
  
  If Vector_IsIni(*list)
    If index1 <> index2
      *cur = *list\current
      pos = *list\pos
      
      If index2 < index1
        SwapLong(@index1, @index2)
      EndIf
      
      If Abs(*list\pos - index1) > Abs(*list\pos - index2) ; Dabord l'indice2
        
        If *list\pos < index2
          *cell2 = Vector_Select(*list, index2)
          *list\current = *cur
          *list\pos = pos
          *cell1 = Vector_Select(*list, index1)
        Else
          If index2+1 < index2 - *list\pos
            *cell1 = Vector_Select(*list, index1)
            *cell2 = Vector_Select(*list, index2)
          Else
            *cell2 = Vector_Select(*list, index2)
            *cell1 = Vector_Select(*list, index1)
          EndIf
        EndIf
          
      Else ; Dabord l'indice1
        
        If *list\pos > index1
          *cell1 = Vector_Select(*list, index1)
          *list\current = *cur
          *list\pos = pos
          *cell2 = Vector_Select(*list, index2)
        Else
          If *list\nb - (index1+1) < index1 - *list\pos
            *cell2 = Vector_Select(*list, index2)
            *cell1 = Vector_Select(*list, index1)
          Else
            *cell1 = Vector_Select(*list, index1)
            *cell2 = Vector_Select(*list, index2)
          EndIf
        EndIf  
      
      EndIf
      *list\current = *cur
      *list\pos = pos
      If *cell1 And *cell2
        *list\sorted  = #False
        ProcedureReturn SwapLong(@*cell1\info, @*cell2\info)
      EndIf
    EndIf
    ProcedureReturn #True
  EndIf
EndProcedure



; -------------- Ajout d'une cellule --------------
;- 13 Add

ProcedureDLL Vector_Add(*list.Vector, val.l)
  Protected *newCell.VCell, *cur.VCell, *prevC.VCell, *nextC.VCell
  
  If Vector_IsIni(*list)
    *newCell = VCell_CreateCell(*list, val)
    If *newCell
      *newCell\Next = #Null
      *newCell\Prev = #Null
      *prevC = #Null
      *nextC = #Null
      
      *cur = *list\current
      If *cur ; La liste a une cellule courante
        *prevC = *cur
        *nextC = *cur\Next
      ElseIf *list\nb ; Pas de cellule courante
        If *list\pos = -1
          *nextC = *list\first ;On est avant-List
        Else
          *prevC = *list\last  ;On est aprs-List
        EndIf
      Else
        ; La liste est vide
      EndIf
      
      If *prevC ; s'il y a une cellule avant
        *prevC\Next = *newCell
        *newCell\prev = *prevC
      Else      ; On est en tte de liste
        *list\first = *newCell
      EndIf
      
      If *nextC ; s'il y a une cellule aprs
        *nextC\prev = *newCell
        *newCell\Next = *nextC
      Else      ; On est en fin de liste
        *list\last = *newCell
      EndIf
      
      If *list\pos < *list\nb
        *list\pos + 1
      EndIf
      *list\nb  + 1
      *list\current = *newCell
      *list\sorted  = #False
      ProcedureReturn *newCell
    EndIf
  EndIf
EndProcedure


ProcedureDLL Vector_AddAtEnd(*list.Vector, val.l)
  If Vector_IsIni(*list)
    *list\current = #Null
    *list\pos = *list\nb
    *list\sorted  = #False
    ProcedureReturn Vector_Add(*list, val)
  EndIf
EndProcedure


ProcedureDLL Vector_AddAtStart(*list.Vector, val.l)
  If Vector_IsIni(*list)
    *list\current = #Null
    *list\pos = -1
    *list\sorted  = #False
    ProcedureReturn Vector_Add(*list, val)
  EndIf
EndProcedure


; ------------- Suppression de cellules --------------
;- 14 Delete

ProcedureDLL Vector_Del(*list.Vector)
  Protected *cell.VCell, *prev.VCell, *suiv.VCell, i.b, *l.long

  If Vector_IsIni(*list)
    *cell = *list\current
    If *cell
      *prev = *cell\Prev
      *suiv = *cell\Next
      
      If *list\type = #LC_TYPE_STR
        FreeMemory(*cell\info)
      ElseIf *list\type > 0
        If *list\complex & #LC_Offsets_Enabled
          For i = 0 To *list\type-1
            If *list\offset[i] >= #LC_TYPE_STR
              *l = *cell\info + i
              FreeMemory(*l\l)
            EndIf
          Next i
        EndIf
        FreeMemory(*cell\info)
      EndIf
      *list\current = #Null
      
      If *prev
        *prev\Next = *suiv
        *list\current = *prev
      Else
        *list\first = *suiv
      EndIf
      
      If *suiv
        *suiv\prev = *prev
        *list\current = *suiv
      Else
        *list\pos - 1
        *list\last = *prev
      EndIf
      
      *list\nb - 1
      If *list\first = #Null  ; Liste vide
        *list\pos = -1
      EndIf
      ProcedureReturn #True
    EndIf
  EndIf
  ProcedureReturn #False
EndProcedure



ProcedureDLL Vector_Del2(*list.Vector, index.l)
  If Vector_Select(*list, index)
    ProcedureReturn Vector_Del(*list)
  EndIf
  ProcedureReturn #False
EndProcedure


; --------------- Min / Max --------------
;- 15 Min and Max

; Ne pas appeler cette fct
Procedure Vector_GetIndexForSort(*index1.l, *index2.l, listSize.l)

  If PeekL(*index1) < 0
    PokeL(*index1, 0)
  EndIf
  If PeekL(*index2) < 0
    PokeL(*index2, listSize-1)
  EndIf
  
  If (PeekL(*index1) > PeekL(*index2)) Or (PeekL(*index1) >= listSize) Or (PeekL(*index2) >= listSize)
    ProcedureReturn #False
  EndIf
  ProcedureReturn #True
EndProcedure


; Renvoi l'indice
ProcedureDLL Vector_MinCell(*list.Vector, index1.l, index2.l, opt.l)
  ; String.opt => sensible  la case
  ; Struct.opt => *fonction
  Protected *save.VCell, *cell.VCell, pos.l, *min.VCell, ind.l

  If Vector_IsIni(*list)
    If Vector_GetIndexForSort(@index1, @index2, *list\nb)
      If index1 = index2
        ProcedureReturn -1
      EndIf
      ;*save = *list\current
      ;pos   = *list\pos
      
      *cell = Vector_Select(*list, index1)
      *min = *cell: ind = index1
      *cell = Vector_Next(*list)
      While *cell>0 And *list\pos<=index2
        If VCell_Compare(*cell\info, *min\info, *list\type, opt) = -1
          *min = *cell
          ind = *list\pos
        EndIf
        *cell = Vector_Next(*list)
      Wend
      
      *list\current = *min
      *list\pos     = ind
      ;*list\current = *save
      ;*list\pos     = pos
      ProcedureReturn ind
    EndIf  
  EndIf
EndProcedure


; Renvoi l'indice
ProcedureDLL Vector_MaxCell(*list.Vector, index1.l, index2.l, opt.l)
  ; String.opt => sensible  la case
  ; Struct.opt => *fonction
  Protected *save.VCell, *cell.VCell, pos.l, *max.VCell, ind.l

  If Vector_IsIni(*list)
    If Vector_GetIndexForSort(@index1, @index2, *list\nb)
      If index1 = index2
        ProcedureReturn -1
      EndIf
      ;*save = *list\current
      ;pos   = *list\pos
      
      *cell = Vector_Select(*list, index1)
      *max = *cell: ind = index1
      *cell = Vector_Next(*list)
      While *cell>0 And *list\pos <=index2
        If VCell_Compare(*cell\info, *max\info, *list\type, opt) = 1
          *max = *cell
          ind = *list\pos
        EndIf
        *cell = Vector_Next(*list)
      Wend
      
      *list\current = *max
      *list\pos     = ind
      ;*list\current = *save
      ;*list\pos     = pos
      ProcedureReturn ind
    EndIf  
  EndIf
EndProcedure






; -------------- QuickSort --------------
;- 17 QuickSort


; Ne pas appeler cette fct
Procedure Vector_QS_Swap(*list.Vector, iMin.l, iMax.l, opt.l)
  Protected temp.l, *min.VCell, *max.VCell, test1.b, test2.b
  
  If opt & #LC_SORT_DESC And *list\type < 1
    test1 = -1: test2 =  1
  Else
    test1 =  1: test2 = -1
  EndIf
  
  *max = Vector_Select(*list, iMax)
  temp = *max\info
  *min = Vector_Select(*list, iMin)
  
  While (iMax > iMin)
    While iMax > iMin And VCell_Compare(*min\info, temp, *list\type, opt) <> test1
      iMin + 1
      *list\current = *list\current\Next
      *list\pos + 1
      *min = *list\current
      ;*min = Vector_Next(*list)
    Wend
    If iMax > iMin
      *max\info = *min\info
      *list\current = *max: *list\pos = iMax
      *max = Vector_Prev(*list): iMax - 1
      While iMax > iMin And VCell_Compare(*max\info, temp, *list\type, opt) <> test2
        iMax - 1
        *list\current = *list\current\prev
        *list\pos - 1
        *max = *list\current
        ;*max = Vector_Prev(*list)
      Wend
      If iMax > iMin
        *min\info = *max\info
        *list\current = *min: *list\pos = iMin
        *list\current = *list\current\Next
        *list\pos + 1
        *min = *list\current
        ;*min = Vector_Next(*list)
        iMin + 1
      EndIf
    EndIf
  Wend
  *max\info = temp
  ProcedureReturn iMax
EndProcedure



; Ne pas appeler cette fct
Procedure Vector_QS_Split(*list.Vector, deb.l, fin.l, opt.l)
  Protected mil.l

  If deb < fin
    mil = Vector_QS_Swap(*list, deb, fin, opt)
    If mil-deb > fin-mil
      Vector_QS_Split(*list, mil+1, fin, opt)
      Vector_QS_Split(*list, deb, mil-1, opt)
    Else
      Vector_QS_Split(*list, deb, mil-1, opt)
      Vector_QS_Split(*list, mil+1, fin, opt)
    EndIf
  EndIf
EndProcedure



ProcedureDLL Vector_Sort(*list.Vector)
  ; String.opt => sensible  la case
  ; Struct.opt => *fonction
  If Vector_IsIni(*list) And *list\type <= #LC_TYPE_STR
    *list\current = *list\first
    *list\pos = 0
    Vector_QS_Split(*list, 0, *list\nb-1, #LC_SORT_INC)
    *list\current   = *list\first
    *list\pos       = 0
    *list\sorted    = #True
    ProcedureReturn #True
  EndIf
EndProcedure

ProcedureDLL Vector_Sort2(*list.Vector, opt.l)
  ; String.opt => sensible  la case
  ; Struct.opt => *fonction
  If Vector_IsIni(*list)
    *list\current = *list\first
    *list\pos = 0
    Vector_QS_Split(*list, 0, *list\nb-1, opt)
    *list\current   = *list\first
    *list\pos       = 0
    *list\sorted    = #True
    ProcedureReturn #True
  EndIf
EndProcedure

ProcedureDLL Vector_Sort3(*list.Vector, opt.l, deb.l, fin.l)
  ; String.opt => sensible  la case
  ; Struct.opt => *fonction
  If Vector_IsIni(*list)
    *list\current = *list\first
    *list\pos = 0
    Vector_GetIndexForSort(@deb, @fin, *list\nb)
    Vector_QS_Split(*list, deb, fin, opt)
    *list\current   = *list\first
    *list\pos       = 0
    *list\sorted    = #True
    ProcedureReturn #True
  EndIf
EndProcedure



; --------------- Search -----------------
;- 18 Search

ProcedureDLL Vector_Search(*list.Vector, val.l, opt.l)
  Protected index.l, s.s
  
  index = -1
  If Vector_IsIni(*list)
    Vector_Reset(*list)
    While index = -1 And Vector_Next(*list)
      ;Debug Vector_GetValue(*list)
      If VCell_Compare(Vector_GetValue(*list), val, *list\type, opt) = 0
        index = *list\pos
      EndIf
    Wend
  EndIf
  ProcedureReturn index
EndProcedure


ProcedureDLL Vector_SearchByEnd(*list.Vector, val.l, opt.l)
  Protected index.l, s.s
  
  index = -1
  If Vector_IsIni(*list)
    Vector_Last(*list)
    Repeat
      If VCell_Compare(Vector_GetValue(*list), val, *list\type, opt) = 0
        index = *list\pos
      EndIf
    Until index > -1 Or Vector_Prev(*list)=#Null
  EndIf
  ProcedureReturn index
EndProcedure


; ---------------- Debug -----------------
;- 19 Debug







; -------------- Suppression de la liste --------------
;- 20 ClearList

ProcedureDLL Vector_Clear(*list.Vector)
  If *list
    Repeat
      *list\current = *list\first
    Until Vector_Del(*list) = #Null
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure


ProcedureDLL Vector_ClearFromCur(*list.Vector)
  Protected pos.l

  If *list
    pos = *list\pos
    Repeat
    Until Vector_Del(*list) = #Null Or pos = *list\nb
    Vector_Last(*list)
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure




; -------------- Ini de la liste --------------
;- 21 IniList

ProcedureDLL Vector_Ini(*list.Vector, type.b)
  If type >= #LC_TYPE_FLT
    If *list
      If *list\ini  ; La liste comporte dj des donnes
        Vector_Clear(*list)
      EndIf
      *list\first   = #Null
      *list\last    = #Null
      *list\current = #Null
      *list\nb      = 0
      *list\pos     = -1
      *list\type    = type
      *list\ini     = #True
      *list\sorted  = #False
      *list\complex = #LC_Offsets_Disabled
      ProcedureReturn #True
    EndIf
  EndIf
  ProcedureReturn #False
EndProcedure


; -------------- Cration d'une liste --------------
;- 22 Creation

ProcedureDLL Vector_Create(type.b)
  Protected i.b, *list.Vector
  If type >= #LC_TYPE_FLT
    If type > 0
      *list = AllocateMemory(SizeOf(Vector)+type)
    Else
      *list = AllocateMemory(SizeOf(Vector))
    EndIf
    If *list
      *list\first   = #Null
      *list\last    = #Null
      *list\current = #Null
      *list\nb      = 0
      *list\pos     = -1
      *list\type    = type
      *list\ini     = #True
      *list\sorted  = #False
      If type >= 0
        *list\complex = #LC_Offsets_Enabled
        For i = 0 To type-1
          *list\offset[i] = #LC_TYPE_LG
        Next i
      Else
        *list\complex = #LC_Offsets_Disabled
      EndIf
      ProcedureReturn *list
    EndIf
  EndIf
  ProcedureReturn #False
EndProcedure


; -------------- Espace mmoire utilis par une liste --------------
;- 23 MemList

ProcedureDLL Vector_Size(*list.Vector)
  Protected *cell.VCell, TotalSize.l, *cur.VCell, pos.l
  
  If Vector_IsIni(*list)
    TotalSize = SizeOf(Vector) + (*list\nb) * SizeOf(VCell)
    ;Debug TotalSize
    ;If *list\opt & #LC_OPT_RECOPY
      If *list\type = #LC_TYPE_STR
        *cur = *list\current
        pos = *list\pos
        Vector_Reset(*list)
        *cell.VCell = Vector_Next(*list)
        While *cell
          ;Debug ">Len : " + Str(Len(PeekS(*cell\info)))
          TotalSize + 1 + Len(PeekS(*cell\info))
          *cell.VCell = Vector_Next(*list)
        Wend
        *list\current = *cur
        *list\pos = pos
      ElseIf *list\type > 0
        TotalSize + ((*list\nb) * (*list\type))
      EndIf
    ;EndIf
    ProcedureReturn TotalSize
  EndIf
EndProcedure


; -------------- Analyse de l'intgrit de la liste --------------
;- 24 Analyse

ProcedureDLL Vector_Analyze(*list.Vector)
  Protected ctrl.Vector, *cell1.VCell, *cell2.VCell
  Protected *cur.VCell, pos.l
  
  If Vector_IsIni(*list)
    If *list\first And *list\last
      If *list\first\prev = #Null And *list\last\Next = #Null
        ; Cration d'un vecteur pour vrifier que la liste ne tourne pas en rond...
        Vector_Ini(ctrl, #LC_TYPE_LG)
        ; Copie de la position actuelle
        *cur = *list\current
        pos = *list\pos
        *cell1 = Vector_First(*list)
        Vector_Add(ctrl, *cell1)
        *cell2 = Vector_Next(*list)
        While *cell2
          If *cell2\prev <> *cell1
            ;Debug "> Cell\prev != Last\Suiv"
            Vector_Clear(ctrl)
            ProcedureReturn #False
          EndIf
          If Vector_Search(ctrl, *cell2, 0) >= 0 ;appartient  Ctrl
            ;Debug "> Cycle"
            Vector_Clear(ctrl)
            ProcedureReturn #False
          EndIf
          If *cell2 = *list\last
            If *cell2\Next
              ;Debug "> Last Cell\suiv != Null"
              Vector_Clear(ctrl)
              ProcedureReturn #False
            EndIf
          EndIf
          *cell1 = *cell2
          *cell2 = Vector_Next(*list)
        Wend
        
        Vector_Clear(ctrl)
        *list\current = *cur
        *list\pos = pos
        ProcedureReturn #True
      EndIf
    Else
      ProcedureReturn #True
    EndIf
  EndIf
EndProcedure



; -------------- Copie d'un vecteur --------------
;- 25 Copie

ProcedureDLL Vector_Copy(*list.Vector)
  Protected *cur.VCell, pos.l, *copy.Vector, i.b
  
  If Vector_IsIni(*list)
    *copy = Vector_Create(*list\type)
    
    If Vector_IsIni(*copy)
      For i = 0 To *list\type
        *copy\offset[i] = *list\offset[i]
      Next i
      *cur = *list\current
      ;pos = *list\pos
      
      *list\current = *list\first
      
      While *list\current
        Vector_Add(*copy, *list\current\info) ; <=> AddAtEnd()
        *list\current = *list\current\Next
      Wend
      
      *list\current = *cur
      ;*list\pos    = pos
      *copy\sorted  = *list\sorted
      *copy\complex = *list\complex
      ProcedureReturn *copy
    EndIf
  EndIf
EndProcedure




; -------------- Cration d'un vecteur --------------
;- 26 ScanDir

; Ne pas appeler cette fct
Procedure Vector_NextEntry()
  Protected FileType.b, FileName$

  FileType = NextDirectoryEntry()
  If FileType = 2
    FileName$ = DirectoryEntryName()
    If FileName$ = "." Or FileName$ = ".."
      ProcedureReturn(Vector_NextEntry())
    EndIf
  EndIf
  ProcedureReturn(FileType)

EndProcedure


; Ne pas appeler cette fct
Procedure Vector_AddFolderToLL(*vect.Vector, basePath$, addPath$, filtre$, opt.b)
  Protected FileType.l, FileName$, hDir.l

  hDir = ExamineDirectory(#PB_Any, basePath$+addPath$, filtre$)
  If hDir
    Repeat
      FileType = Vector_NextEntry()
      If FileType
        FileName$ = addPath$ + DirectoryEntryName()
        If FileType = 2
          If opt & #LC_SCANDIR_RECURSIVE
            Vector_AddFolderToLL(*vect, basePath$, FileName$+"\", filtre$, opt)
            UseDirectory(hDir)
          ElseIf opt & #LC_SCANDIR_FOLDER
            Vector_Add(*vect, @FileName$)
          EndIf
        Else
          Vector_Add(*vect, @FileName$)
        EndIf
      EndIf
    Until FileType = 0
  EndIf
EndProcedure



ProcedureDLL Vector_ScanDir(dir$)
  Protected *vect.Vector

  *vect = Vector_Create(#LC_TYPE_STR)
  Vector_AddFolderToLL(*vect, dir$, "", "*.*", #LC_SCANDIR_NOFOLDER)
  ProcedureReturn *vect
EndProcedure


ProcedureDLL Vector_ScanDir2(dir$, filtre$)
  Protected *vect.Vector

  *vect = Vector_Create(#LC_TYPE_STR)
  Vector_AddFolderToLL(*vect, dir$, "", filtre$, #LC_SCANDIR_NOFOLDER)
  ProcedureReturn *vect
EndProcedure


ProcedureDLL Vector_ScanDir3(dir$, filtre$, opt.b)
  Protected *vect.Vector

  *vect = Vector_Create(#LC_TYPE_STR)
  Vector_AddFolderToLL(*vect, dir$, "", filtre$, opt)
  If opt & #LC_SCANDIR_SORT
    Vector_Sort(*vect)
  EndIf
  ProcedureReturn *vect
EndProcedure







; -------------- Implode / Explode --------------
;- 27 Im Ex Plode


ProcedureDLL Vector_Explode(sentence$, split$)
  Protected i.l, nb.l, temp$

  *list = Vector_Create(#LC_TYPE_STR)
  nb = CountString(sentence$, split$) + 1
  For i = 1 To nb
    temp$ = StringField(sentence$, i, split$)
    Vector_AddAtEnd(*list, @temp$)
  Next i
  ProcedureReturn *list
EndProcedure


ProcedureDLL.s Vector_Implode(*list.Vector, split$)
  Protected temp$, *cur.VCell, pos.l

  If Vector_IsIni(*list) And *list\type = #LC_TYPE_STR
    *cur = *list\current
    pos = *list\pos
    
    *list\current = #Null
    *list\pos = -1
    
    temp$ = ""
    While(Vector_Next(*list))
      If *list\pos <> 0
        temp$ + split$
      EndIf
      temp$ = temp$ + PeekS(*list\current\info)
    Wend
    
    *list\current = *cur
    *list\pos = pos
    ProcedureReturn temp$
  EndIf
EndProcedure


ProcedureDLL.l Vector_ImplodePtr(*list.Vector, split$)
  Protected temp$, *cur.VCell, pos.l, *ptrMem.l

  If Vector_IsIni(*list) And *list\type = #LC_TYPE_STR
    *cur = *list\current
    pos = *list\pos
    
    *list\current = #Null
    *list\pos = -1
    
    temp$ = ""
    While(Vector_Next(*list))
      If *list\pos <> 0
        temp$ + split$
      EndIf
      temp$ = temp$ + PeekS(*list\current\info)
    Wend
    
    *list\current = *cur
    *list\pos = pos
    *ptrMem = AllocateMemory(Len(temp$)+1)
    CopyMemory(@temp$, *ptrMem, Len(temp$))
    ProcedureReturn *ptrMem
  EndIf
EndProcedure



; -------------- Collision / Combine --------------
;- 28 Collision Combine



ProcedureDLL Vector_Collision(*list1.Vector, *list2.Vector, option.l)
  Protected *Final.Vector, *cur1.VCell, pos1.l, *cur2.VCell, pos2.l

  If Vector_IsIni(*list1) And Vector_IsIni(*list2)
    If *list1\type = *list2\type
      *cur1 = *list1\current
      pos1  = *list1\pos
      *cur2 = *list2\current
      pos2  = *list2\pos

      *Final = Vector_Create(*list1\type)
      Vector_Reset(*list1)
      While Vector_Next(*list1)
        If Vector_Search(*list2, *list1\current\info, option) <> -1
          If Vector_Search(*Final, *list1\current\info, option) = -1
            Vector_AddAtEnd(*Final, *list1\current\info)
          EndIf
        EndIf
      Wend
      *list1\current = *cur1
      *list1\pos = pos1
      *list2\current = *cur2
      *list2\pos = pos2
      *Final\sorted = *list1\sorted
      ProcedureReturn *Final
    EndIf
  EndIf
EndProcedure


ProcedureDLL Vector_Combine(*list1.Vector, *list2.Vector, option.l)
  Protected *Final.Vector, *cur1.VCell, pos1.l, *cur2.VCell, pos2.l

  If Vector_IsIni(*list1) And Vector_IsIni(*list2)
    If *list1\type = *list2\type
      *cur1 = *list1\current
      pos1  = *list1\pos
      *cur2 = *list2\current
      pos2  = *list2\pos

      *Final = Vector_Create(*list1\type)
      Vector_Reset(*list1)
      While Vector_Next(*list1)
        If Vector_Search(*Final, *list1\current\info, option) = -1
          Vector_AddAtEnd(*Final, *list1\current\info)
        EndIf
      Wend
      Vector_Reset(*list2)
      While Vector_Next(*list2)
        If Vector_Search(*list1, *list2\current\info, option) = -1
          If Vector_Search(*Final, *list2\current\info, option) = -1
            Vector_AddAtEnd(*Final, *list2\current\info)
          EndIf
        EndIf
      Wend

      *list1\current = *cur1
      *list1\pos = pos1
      *list2\current = *cur2
      *list2\pos = pos2
      ProcedureReturn *Final
    EndIf
  EndIf
EndProcedure




; ------------------------- ForEach --------------------------
;- 29 ForEach



ProcedureDLL Vector_ForEach(*list.Vector, *fonction.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell
  
  If Vector_IsIni(*list)
    *cell  = *list\first
    While *cell
      CallFunctionFast(*fonction, *cell)
      *cell = *cell\Next
    Wend
  EndIf
EndProcedure


ProcedureDLL Vector_ForEach2(*list.Vector, *fonction.l, par1.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell
  
  If Vector_IsIni(*list)
    *cell  = *list\first
    While *cell
      CallFunctionFast(*fonction, *cell, par1)
      *cell = *cell\Next
    Wend
  EndIf
EndProcedure

ProcedureDLL Vector_ForEach3(*list.Vector, *fonction.l, par1.l, par2.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell
  
  If Vector_IsIni(*list)
    *cell  = *list\first
    While *cell
      CallFunctionFast(*fonction, *cell, par1, par2)
      *cell = *cell\Next
    Wend
  EndIf
EndProcedure

ProcedureDLL Vector_ForEach4(*list.Vector, *fonction.l, par1.l, par2.l, par3.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell
  
  If Vector_IsIni(*list)
    *cell  = *list\first
    While *cell
      CallFunctionFast(*fonction, *cell, par1, par2, par3)
      *cell = *cell\Next
    Wend
  EndIf
EndProcedure

ProcedureDLL Vector_ForEach5(*list.Vector, *fonction.l, par1.l, par2.l, par3.l, par4.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell
  
  If Vector_IsIni(*list)
    *cell  = *list\first
    While *cell
      CallFunctionFast(*fonction, *cell, par1, par2, par3, par4)
      *cell = *cell\Next
    Wend
  EndIf
EndProcedure

ProcedureDLL Vector_ForEach6(*list.Vector, *fonction.l, par1.l, par2.l, par3.l, par4.l, par5.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell
  
  If Vector_IsIni(*list)
    *cell  = *list\first
    While *cell
      CallFunctionFast(*fonction, *cell, par1, par2, par3, par4, par5)
      *cell = *cell\Next
    Wend
  EndIf
EndProcedure

ProcedureDLL Vector_ForEach7(*list.Vector, *fonction.l, par1.l, par2.l, par3.l, par4.l, par5.l, par6.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell
  
  If Vector_IsIni(*list)
    *cell  = *list\first
    While *cell
      CallFunctionFast(*fonction, *cell, par1, par2, par3, par4, par5, par6)
      *cell = *cell\Next
    Wend
  EndIf
EndProcedure




; ---------------------- ForEachOf -----------------------
;- 29 ForEachOf



ProcedureDLL Vector_ForEachOf(*list.Vector, *fonction.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell, pos.l
  
  If Vector_IsIni(*list)
    *cell = *list\current
    pos   = *list\pos
    *list\current = #Null
    *list\pos = -1
    While Vector_Next(*list)
      CallFunctionFast(*fonction, *list)
    Wend
    *list\current = *cell
    *list\pos = pos
  EndIf
EndProcedure


ProcedureDLL Vector_ForEachOf2(*list.Vector, *fonction.l, par1.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell, pos.l
  
  If Vector_IsIni(*list)
    *cell = *list\current
    pos   = *list\pos
    *list\current = #Null
    *list\pos = -1
    While Vector_Next(*list)
      CallFunctionFast(*fonction, *list, par1)
    Wend
    *list\current = *cell
    *list\pos = pos
  EndIf
EndProcedure

ProcedureDLL Vector_ForEachOf3(*list.Vector, *fonction.l, par1.l, par2.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell, pos.l
  
  If Vector_IsIni(*list)
    *cell = *list\current
    pos   = *list\pos
    *list\current = #Null
    *list\pos = -1
    While Vector_Next(*list)
      CallFunctionFast(*fonction, *list, par1, par2)
    Wend
    *list\current = *cell
    *list\pos = pos
  EndIf
EndProcedure

ProcedureDLL Vector_ForEachOf4(*list.Vector, *fonction.l, par1.l, par2.l, par3.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell, pos.l
  
  If Vector_IsIni(*list)
    *cell = *list\current
    pos   = *list\pos
    *list\current = #Null
    *list\pos = -1
    While Vector_Next(*list)
      CallFunctionFast(*fonction, *list, par1, par2, par3)
    Wend
    *list\current = *cell
    *list\pos = pos
  EndIf
EndProcedure

ProcedureDLL Vector_ForEachOf5(*list.Vector, *fonction.l, par1.l, par2.l, par3.l, par4.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell, pos.l
  
  If Vector_IsIni(*list)
    *cell = *list\current
    pos   = *list\pos
    *list\current = #Null
    *list\pos = -1
    While Vector_Next(*list)
      CallFunctionFast(*fonction, *list, par1, par2, par3, par4)
    Wend
    *list\current = *cell
    *list\pos = pos
  EndIf
EndProcedure

ProcedureDLL Vector_ForEachOf6(*list.Vector, *fonction.l, par1.l, par2.l, par3.l, par4.l, par5.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell, pos.l
  
  If Vector_IsIni(*list)
    *cell = *list\current
    pos   = *list\pos
    *list\current = #Null
    *list\pos = -1
    While Vector_Next(*list)
      CallFunctionFast(*fonction, *list, par1, par2, par3, par4, par5)
    Wend
    *list\current = *cell
    *list\pos = pos
  EndIf
EndProcedure

ProcedureDLL Vector_ForEachOf7(*list.Vector, *fonction.l, par1.l, par2.l, par3.l, par4.l, par5.l, par6.l)  ; Ne modifie pas le ptr de la liste
  Protected *cell.VCell, pos.l
  
  If Vector_IsIni(*list)
    *cell = *list\current
    pos   = *list\pos
    *list\current = #Null
    *list\pos = -1
    While Vector_Next(*list)
      CallFunctionFast(*fonction, *list, par1, par2, par3, par4, par5, par6)
    Wend
    *list\current = *cell
    *list\pos = pos
  EndIf
EndProcedure





; -------------- CreateSafeDirectory --------------
;- 30 CreateSafeDirectory


ProcedureDLL.b Vector_CreateSafeDirectory(dir$)
  Protected *v1.Vector, *v2.Vector, ok.b, dir2$, Buffer.s, *mem.l
  
  ok = #False
  dir$ = ReplaceString(dir$, "/", "\")
  dir2$ = StringField(dir$, 1, "\")
  If PeekB(@dir2$) = 37 And Right(dir2$,1) = "%"
    Buffer.s = Space(255) 
    GetEnvironmentVariable_(Mid(dir2$, 2, Len(dir2$)-2), Buffer, 255)
    dir$ = Buffer + Right(dir$, Len(dir$)-Len(dir2$))
  EndIf
  *v1 = Vector_Explode(dir$, "\")
  If *v1\last
    Vector_Last(*v1)
    If PeekS(*v1\current\info) = ""
      Vector_Del(*v1)
    EndIf
    *v2 = Vector_Copy(*v1)
    *mem = Vector_ImplodePtr(*v1, "\")
    While FileSize(PeekS(*mem)) =-1 And *v1\nb > 0
      ;MessageRequester("aa", PeekS(*mem), 0)
      If CreateDirectory(PeekS(*mem))
        ok = #True
        Break
      EndIf
      Vector_Last(*v1)
      Vector_Del(*v1)
      FreeMemory(*mem)
      *mem = Vector_ImplodePtr(*v1, "\")
    Wend
    FreeMemory(*mem)
    ;ProcedureReturn ok
    If ok
      Vector_Select(*v2, *v1\pos)
      While Vector_Next(*v2)
        Vector_AddAtEnd(*v1, *v2\current\info)
        *mem = Vector_ImplodePtr(*v1, "\")
        If CreateDirectory(PeekS(*mem)) = #Null
          ok = #False
          Break
        EndIf
        FreeMemory(*mem)
      Wend
    EndIf
    FreeMemory(*mem)
    Vector_Clear(*v1)
    Vector_Clear(*v2)
  EndIf
  ProcedureReturn ok
  FreeMemory(*v1)
EndProcedure






; -------------- VectorFile --------------
;- 31 VectorFile


ProcedureDLL Vector_LoadFile(Fichier$)
  Protected hFile.l, *vector.Vector, line$
  
  hFile = ReadFile(#PB_Any, Fichier$)
  If hFile
    *vector = Vector_Create(#LC_TYPE_STR)
    While ~Eof(hFile)
      line$ = ReadString()
      Vector_Add(*vector, @line$)
    Wend
    CloseFile(hFile)
    ProcedureReturn *vector
  Else
    ProcedureReturn #Null
  EndIf
EndProcedure




ProcedureDLL Vector_SaveFile(*vector.Vector, Fichier$)
  Protected hFile.l, *vector.Vector, *cell.VCell, pos.l
  
  If Vector_IsIni(*vector) And *vector\type = #LC_TYPE_STR
    DeleteFile(Fichier$)
    hFile = OpenFile(#PB_Any, Fichier$)
    If hFile
      *cell = *vector\current
      pos   = *vector\pos
      Vector_Reset(*vector)
      While Vector_Next(*vector)
        WriteStringN(PeekS(*vector\current\info))
      Wend
      CloseFile(hFile)
      *vector\current = *cell
      *vector\pos     = pos
      ProcedureReturn #True
    EndIf
  EndIf
  ProcedureReturn #False
EndProcedure





; -------------- VectorString --------------
;- 32 VectorString







; ExecutableFormat=Windows
; EOF