
IncludeFile "ProceduresDebug.pb"


; Affichage de la cellule courante
Procedure Vector_Debug_Point(*vect.Vector)
  Protected *p.Point
  
  *p = Vector_GetValue(*vect)
  If *p
    Debug "Point : " + Str(Vector_Index(*vect))
    Debug "  x : " + Str(*p\x)
    Debug "  y : " + Str(*p\y)
  EndIf
EndProcedure


; Comparaison sur les 'x', puis les 'y'
; return : '1' si p1 < p2
;          '0' si p1 = p2
;          else '-1'
Procedure Point_Min(*p1.Point, *p2.Point)
  If *p1\x > *p2\x        ; p1 > p2
    ProcedureReturn -1
  ElseIf *p1\x < *p2\x    ; p1 < p2
    ProcedureReturn 1
  Else
    If *p1\y > *p2\y
      ProcedureReturn -1 ; p1 > p2
    ElseIf *p1\y < *p2\y
      ProcedureReturn 1  ; p1 < p2
    Else
      ProcedureReturn 0  ; p1 = p2
    EndIf
  EndIf
EndProcedure


Procedure Point_Max(*p1.Point, *p2.Point)
  ProcedureReturn Point_Min(*p1, *p2) * (-1)
EndProcedure



; Test avec des Points
; --------------------

;/ Initialisation du Vector (type Point)
myVector.Vector
Vector_Ini(myVector, SizeOf(Point))


;/ Ajout de 4 elements
p.Point
p\x = 100
p\y = 50
Vector_Add(myVector, p)
p\x = 200
Vector_Add(myVector, p)
p\y = 100
Vector_Add(myVector, p)
p\y = 10
Vector_Add(myVector, p)

;/ Affichage du contenu du vecteur
Debug "> Affichage <"
Vector_Reset(myVector)
While Vector_Next(myVector)
  Vector_Debug_Point(myVector)
Wend

Debug " "
Debug "< tri dcroissant >"
Debug " "

Vector_Sort(myVector, @Point_Min())

Debug "> Affichage <"
Vector_Reset(myVector)
While Vector_Next(myVector)
  Vector_Debug_Point(myVector)
Wend


Debug " "
Debug "< tri croissant >"
Debug " "

Vector_Sort(myVector, @Point_Max())

Debug "> Affichage <"
Vector_Reset(myVector)
While Vector_Next(myVector)
  Vector_Debug_Point(myVector)
Wend

End


; ExecutableFormat=
; EOF